Subject: Re: [patch 02/18] sundance: PHY address form 0, only for device I D 0x0200 (IP100A) (20070605)

From: Jesse Huang <[email-masked]>
Date: Wed, 05 Sep 2007 14:39:48 -0400

Dear Jeff:
We found current sundance.c in kernel 2.6.22 is working fine for IP100A.
We need not to modify following codes:
> -       for (phy = 1; phy <= 32 && phy_idx < MII_CNT; phy++) {
> +       if (sundance_pci_tbl[np->chip_id].device == 0x0200)
> +               phy = 0;
> +       else
> +               phy = 1;
> +       for (; phy <= 32 && phy_idx < MII_CNT; phy++) {

Current code will find IP100A at 0 when phy was equ to 32.
for (phy = 1; phy <= 32 && phy_idx < MII_CNT; phy++) {
		int phyx = phy & 0x1f;
		int mii_status = mdio_read(dev, phyx, MII_BMSR);
		if (mii_status != 0xffff  &&  mii_status != 0x0000) {
			np->phys[phy_idx++] = phyx;
			np->mii_if.advertising = mdio_read(dev, phyx, MII_ADVERTISE);
			if ((mii_status & 0x0040) == 0)
				np->mii_preamble_required++;
			printk(KERN_INFO "%s: MII PHY found at address %d, status "
				   "0x%4.4x advertising %4.4x.\n",
				   dev->name, phyx, mii_status, np->mii_if.advertising);
		}
	}

So, we hope you can drop this patch "[patch 02/18] sundance: PHY address
form 0, only for device I D 0x0200 (IP100A) (20070605)"

Thanks a lot!

Best Regards,
Jesse Huang

-----Original Message-----
From: Jeff Garzik [mailto:[email-masked]] 
Sent: Monday, September 03, 2007 6:43 PM
To: ¶À«Ø¿³-Jesse
Cc: [email-masked]; [email-masked]
Subject: Re: [patch 02/18] sundance: PHY address form 0, only for device
I D 0x0200 (IP100A) (20070605)

¶À«Ø¿³-Jesse wrote:
> +++ a/drivers/net/sundance.c
> @@ -559,7 +559,11 @@ static int __devinit sundance_probe1 (st
>          * It seems some phys doesn't deal well with address 0 being
> accessed
>          * first, so leave address zero to the end of the loop (32 &
31).
>          */
> -       for (phy = 1; phy <= 32 && phy_idx < MII_CNT; phy++) {
> +       if (sundance_pci_tbl[np->chip_id].device == 0x0200)
> +               phy = 0;
> +       else
> +               phy = 1;
> +       for (; phy <= 32 && phy_idx < MII_CNT; phy++) {

As I noted in the last email, this patch still has a bug:

In the above loop code being modified, you need to change two things:

1) Initial loop value
2) Loop terminating condition

Your patch only performs change #1.

	Jeff